Index: drivers/filesystems/btrfs/CMakeLists.txt
===================================================================
--- drivers/filesystems/btrfs/CMakeLists.txt	(révision 75772)
+++ drivers/filesystems/btrfs/CMakeLists.txt	(copie de travail)
@@ -20,13 +20,17 @@
     free-space.c
     fsctl.c
     galois.c
+    guid.c
     pnp.c
     read.c
     registry.c
     reparse.c
+    scrub.c
     search.c
     security.c
+    send.c
     treefuncs.c
+    volume.c
     worker-thread.c
     write.c
     btrfs_drv.h)
@@ -37,5 +41,4 @@
 set_module_type(btrfs kernelmodedriver)
 target_link_libraries(btrfs rtlver ntoskrnl_vista zlib_solo wdmguid ${PSEH_LIB})
 add_importlibs(btrfs ntoskrnl hal)
-add_pch(btrfs btrfs_drv.h SOURCE)
 add_cd_file(TARGET btrfs DESTINATION reactos/system32/drivers NO_CAB FOR all)
Index: drivers/filesystems/btrfs/balance.c
===================================================================
--- drivers/filesystems/btrfs/balance.c	(révision 75772)
+++ drivers/filesystems/btrfs/balance.c	(copie de travail)
@@ -1,22 +1,23 @@
-/* Copyright (c) Mark Harmstone 2016
- * 
+/* Copyright (c) Mark Harmstone 2016-17
+ *
  * This file is part of WinBtrfs.
- * 
+ *
  * WinBtrfs is free software: you can redistribute it and/or modify
  * it under the terms of the GNU Lesser General Public Licence as published by
  * the Free Software Foundation, either version 3 of the Licence, or
  * (at your option) any later version.
- * 
+ *
  * WinBtrfs is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU Lesser General Public Licence for more details.
- * 
+ *
  * You should have received a copy of the GNU Lesser General Public Licence
  * along with WinBtrfs.  If not, see <http://www.gnu.org/licenses/>. */
 
 #include "btrfs_drv.h"
 #include "btrfsioctl.h"
+#include <ntddstor.h>
 
 typedef struct {
     UINT64 address;
@@ -31,12 +32,13 @@
 
 typedef struct {
     UINT8 type;
-    
+    UINT64 hash;
+
     union {
         TREE_BLOCK_REF tbr;
         SHARED_BLOCK_REF sbr;
     };
-    
+
     metadata_reloc* parent;
     BOOL top;
     LIST_ENTRY list_entry;
@@ -54,56 +56,67 @@
 
 typedef struct {
     UINT8 type;
-    
+    UINT64 hash;
+
     union {
         EXTENT_DATA_REF edr;
         SHARED_DATA_REF sdr;
     };
-    
+
     metadata_reloc* parent;
     LIST_ENTRY list_entry;
 } data_reloc_ref;
 
-extern LIST_ENTRY volumes;
-extern ERESOURCE volumes_lock;
+#ifndef _MSC_VER // not in mingw yet
+#define DEVICE_DSM_FLAG_TRIM_NOT_FS_ALLOCATED 0x80000000
+#endif
 
-static NTSTATUS add_metadata_reloc(device_extension* Vcb, LIST_ENTRY* items, traverse_ptr* tp, BOOL skinny, metadata_reloc** mr2, chunk* c, LIST_ENTRY* rollback) {
+#define BALANCE_UNIT 0x100000 // only read 1 MB at a time
+
+static NTSTATUS add_metadata_reloc(_Requires_exclusive_lock_held_(_Curr_->tree_lock) device_extension* Vcb, LIST_ENTRY* items, traverse_ptr* tp,
+                                   BOOL skinny, metadata_reloc** mr2, chunk* c, LIST_ENTRY* rollback) {
+    NTSTATUS Status;
     metadata_reloc* mr;
     EXTENT_ITEM* ei;
     UINT16 len;
     UINT64 inline_rc;
     UINT8* ptr;
-    
+
     mr = ExAllocatePoolWithTag(PagedPool, sizeof(metadata_reloc), ALLOC_TAG);
     if (!mr) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     mr->address = tp->item->key.obj_id;
     mr->data = NULL;
     mr->ei = (EXTENT_ITEM*)tp->item->data;
     mr->system = FALSE;
     InitializeListHead(&mr->refs);
-    
-    delete_tree_item(Vcb, tp, rollback);
-    
+
+    Status = delete_tree_item(Vcb, tp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("delete_tree_item returned %08x\n", Status);
+        ExFreePool(mr);
+        return Status;
+    }
+
     if (!c)
         c = get_chunk_from_address(Vcb, tp->item->key.obj_id);
-        
+
     if (c) {
         ExAcquireResourceExclusiveLite(&c->lock, TRUE);
-        
-        decrease_chunk_usage(c, Vcb->superblock.node_size);
-        
-        space_list_add(Vcb, c, TRUE, tp->item->key.obj_id, Vcb->superblock.node_size, rollback);
-        
+
+        c->used -= Vcb->superblock.node_size;
+
+        space_list_add(c, tp->item->key.obj_id, Vcb->superblock.node_size, rollback);
+
         ExReleaseResourceLite(&c->lock);
     }
-    
+
     ei = (EXTENT_ITEM*)tp->item->data;
     inline_rc = 0;
-    
+
     len = tp->item->size - sizeof(EXTENT_ITEM);
     ptr = (UINT8*)tp->item->data + sizeof(EXTENT_ITEM);
     if (!skinny) {
@@ -110,14 +123,14 @@
         len -= sizeof(EXTENT_ITEM2);
         ptr += sizeof(EXTENT_ITEM2);
     }
-    
+
     while (len > 0) {
         UINT8 secttype = *ptr;
-        ULONG sectlen = secttype == TYPE_TREE_BLOCK_REF ? sizeof(TREE_BLOCK_REF) : (secttype == TYPE_SHARED_BLOCK_REF ? sizeof(SHARED_BLOCK_REF) : 0);
+        UINT16 sectlen = secttype == TYPE_TREE_BLOCK_REF ? sizeof(TREE_BLOCK_REF) : (secttype == TYPE_SHARED_BLOCK_REF ? sizeof(SHARED_BLOCK_REF) : 0);
         metadata_reloc_ref* ref;
-        
+
         len--;
-        
+
         if (sectlen > len) {
             ERR("(%llx,%x,%llx): %x bytes left, expecting at least %x\n", tp->item->key.obj_id, tp->item->key.obj_type, tp->item->key.offset, len, sectlen);
             return STATUS_INTERNAL_ERROR;
@@ -127,13 +140,13 @@
             ERR("(%llx,%x,%llx): unrecognized extent type %x\n", tp->item->key.obj_id, tp->item->key.obj_type, tp->item->key.offset, secttype);
             return STATUS_INTERNAL_ERROR;
         }
-        
+
         ref = ExAllocatePoolWithTag(PagedPool, sizeof(metadata_reloc_ref), ALLOC_TAG);
         if (!ref) {
             ERR("out of memory\n");
             return STATUS_INSUFFICIENT_RESOURCES;
         }
-        
+
         if (secttype == TYPE_TREE_BLOCK_REF) {
             ref->type = TYPE_TREE_BLOCK_REF;
             RtlCopyMemory(&ref->tbr, ptr + sizeof(UINT8), sizeof(TREE_BLOCK_REF));
@@ -147,99 +160,108 @@
             ExFreePool(ref);
             return STATUS_INTERNAL_ERROR;
         }
-        
+
         ref->parent = NULL;
         ref->top = FALSE;
         InsertTailList(&mr->refs, &ref->list_entry);
-        
+
         len -= sectlen;
         ptr += sizeof(UINT8) + sectlen;
     }
-    
+
     if (inline_rc < ei->refcount) { // look for non-inline entries
         traverse_ptr tp2 = *tp, next_tp;
-        
+
         while (find_next_item(Vcb, &tp2, &next_tp, FALSE, NULL)) {
             tp2 = next_tp;
-            
+
             if (tp2.item->key.obj_id == tp->item->key.obj_id) {
-                if (tp2.item->key.obj_type == TYPE_TREE_BLOCK_REF && tp2.item->size >= sizeof(TREE_BLOCK_REF)) {
+                if (tp2.item->key.obj_type == TYPE_TREE_BLOCK_REF) {
                     metadata_reloc_ref* ref = ExAllocatePoolWithTag(PagedPool, sizeof(metadata_reloc_ref), ALLOC_TAG);
                     if (!ref) {
                         ERR("out of memory\n");
                         return STATUS_INSUFFICIENT_RESOURCES;
                     }
-                    
+
                     ref->type = TYPE_TREE_BLOCK_REF;
-                    RtlCopyMemory(&ref->tbr, tp2.item->data, sizeof(TREE_BLOCK_REF));
+                    ref->tbr.offset = tp2.item->key.offset;
                     ref->parent = NULL;
                     ref->top = FALSE;
                     InsertTailList(&mr->refs, &ref->list_entry);
-                    
-                    delete_tree_item(Vcb, &tp2, rollback);
-                } else if (tp2.item->key.obj_type == TYPE_SHARED_BLOCK_REF && tp2.item->size >= sizeof(SHARED_BLOCK_REF)) {
+
+                    Status = delete_tree_item(Vcb, &tp2);
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("delete_tree_item returned %08x\n", Status);
+                        return Status;
+                    }
+                } else if (tp2.item->key.obj_type == TYPE_SHARED_BLOCK_REF) {
                     metadata_reloc_ref* ref = ExAllocatePoolWithTag(PagedPool, sizeof(metadata_reloc_ref), ALLOC_TAG);
                     if (!ref) {
                         ERR("out of memory\n");
                         return STATUS_INSUFFICIENT_RESOURCES;
                     }
-                    
+
                     ref->type = TYPE_SHARED_BLOCK_REF;
-                    RtlCopyMemory(&ref->sbr, tp2.item->data, sizeof(SHARED_BLOCK_REF));
+                    ref->sbr.offset = tp2.item->key.offset;
                     ref->parent = NULL;
                     ref->top = FALSE;
                     InsertTailList(&mr->refs, &ref->list_entry);
-                    
-                    delete_tree_item(Vcb, &tp2, rollback);
+
+                    Status = delete_tree_item(Vcb, &tp2);
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("delete_tree_item returned %08x\n", Status);
+                        return Status;
+                    }
                 }
             } else
                 break;
         }
     }
-    
+
     InsertTailList(items, &mr->list_entry);
-    
+
     if (mr2)
         *mr2 = mr;
-    
+
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS add_metadata_reloc_parent(device_extension* Vcb, LIST_ENTRY* items, UINT64 address, metadata_reloc** mr2, LIST_ENTRY* rollback) {
+static NTSTATUS add_metadata_reloc_parent(_Requires_exclusive_lock_held_(_Curr_->tree_lock) device_extension* Vcb, LIST_ENTRY* items,
+                                          UINT64 address, metadata_reloc** mr2, LIST_ENTRY* rollback) {
     LIST_ENTRY* le;
     KEY searchkey;
     traverse_ptr tp;
     BOOL skinny = FALSE;
     NTSTATUS Status;
-    
+
     le = items->Flink;
     while (le != items) {
         metadata_reloc* mr = CONTAINING_RECORD(le, metadata_reloc, list_entry);
-        
+
         if (mr->address == address) {
             *mr2 = mr;
             return STATUS_SUCCESS;
         }
-        
+
         le = le->Flink;
     }
-    
+
     searchkey.obj_id = address;
     searchkey.obj_type = TYPE_METADATA_ITEM;
     searchkey.offset = 0xffffffffffffffff;
-    
+
     Status = find_item(Vcb, Vcb->extent_root, &tp, &searchkey, FALSE, NULL);
     if (!NT_SUCCESS(Status)) {
         ERR("find_item returned %08x\n", Status);
         return Status;
     }
-    
+
     if (tp.item->key.obj_id == address && tp.item->key.obj_type == TYPE_METADATA_ITEM && tp.item->size >= sizeof(EXTENT_ITEM))
         skinny = TRUE;
     else if (tp.item->key.obj_id == address && tp.item->key.obj_type == TYPE_EXTENT_ITEM && tp.item->key.offset == Vcb->superblock.node_size &&
              tp.item->size >= sizeof(EXTENT_ITEM)) {
         EXTENT_ITEM* ei = (EXTENT_ITEM*)tp.item->data;
-        
+
         if (!(ei->flags & EXTENT_ITEM_TREE_BLOCK)) {
             ERR("EXTENT_ITEM for %llx found, but tree flag not set\n", address);
             return STATUS_INTERNAL_ERROR;
@@ -248,17 +270,60 @@
         ERR("could not find valid EXTENT_ITEM for address %llx\n", address);
         return STATUS_INTERNAL_ERROR;
     }
-    
+
     Status = add_metadata_reloc(Vcb, items, &tp, skinny, mr2, NULL, rollback);
     if (!NT_SUCCESS(Status)) {
         ERR("add_metadata_reloc returned %08x\n", Status);
         return Status;
     }
-    
+
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS add_metadata_reloc_extent_item(device_extension* Vcb, metadata_reloc* mr, LIST_ENTRY* rollback) {
+static void sort_metadata_reloc_refs(metadata_reloc* mr) {
+    LIST_ENTRY newlist, *le;
+
+    if (mr->refs.Flink == mr->refs.Blink) // 0 or 1 items
+        return;
+
+    // insertion sort
+
+    InitializeListHead(&newlist);
+
+    while (!IsListEmpty(&mr->refs)) {
+        metadata_reloc_ref* ref = CONTAINING_RECORD(RemoveHeadList(&mr->refs), metadata_reloc_ref, list_entry);
+        BOOL inserted = FALSE;
+
+        if (ref->type == TYPE_TREE_BLOCK_REF)
+            ref->hash = ref->tbr.offset;
+        else if (ref->type == TYPE_SHARED_BLOCK_REF)
+            ref->hash = ref->parent->new_address;
+
+        le = newlist.Flink;
+        while (le != &newlist) {
+            metadata_reloc_ref* ref2 = CONTAINING_RECORD(le, metadata_reloc_ref, list_entry);
+
+            if (ref->type < ref2->type || (ref->type == ref2->type && ref->hash > ref2->hash)) {
+                InsertHeadList(le->Blink, &ref->list_entry);
+                inserted = TRUE;
+                break;
+            }
+
+            le = le->Flink;
+        }
+
+        if (!inserted)
+            InsertTailList(&newlist, &ref->list_entry);
+    }
+
+    newlist.Flink->Blink = &mr->refs;
+    newlist.Blink->Flink = &mr->refs;
+    mr->refs.Flink = newlist.Flink;
+    mr->refs.Blink = newlist.Blink;
+}
+
+static NTSTATUS add_metadata_reloc_extent_item(_Requires_exclusive_lock_held_(_Curr_->tree_lock) device_extension* Vcb, metadata_reloc* mr) {
+    NTSTATUS Status;
     LIST_ENTRY* le;
     UINT64 rc = 0;
     UINT16 inline_len;
@@ -266,18 +331,20 @@
     metadata_reloc_ref* first_noninline = NULL;
     EXTENT_ITEM* ei;
     UINT8* ptr;
-    
+
     inline_len = sizeof(EXTENT_ITEM);
     if (!(Vcb->superblock.incompat_flags & BTRFS_INCOMPAT_FLAGS_SKINNY_METADATA))
         inline_len += sizeof(EXTENT_ITEM2);
-    
+
+    sort_metadata_reloc_refs(mr);
+
     le = mr->refs.Flink;
     while (le != &mr->refs) {
         metadata_reloc_ref* ref = CONTAINING_RECORD(le, metadata_reloc_ref, list_entry);
-        ULONG extlen = 0;
-        
+        UINT16 extlen = 0;
+
         rc++;
-        
+
         if (ref->type == TYPE_TREE_BLOCK_REF)
             extlen += sizeof(TREE_BLOCK_REF);
         else if (ref->type == TYPE_SHARED_BLOCK_REF)
@@ -284,142 +351,121 @@
             extlen += sizeof(SHARED_BLOCK_REF);
 
         if (all_inline) {
-            if (inline_len + 1 + extlen > Vcb->superblock.node_size / 4) {
+            if ((ULONG)(inline_len + 1 + extlen) > (Vcb->superblock.node_size >> 2)) {
                 all_inline = FALSE;
                 first_noninline = ref;
             } else
                 inline_len += extlen + 1;
         }
-        
+
         le = le->Flink;
     }
-    
+
     ei = ExAllocatePoolWithTag(PagedPool, inline_len, ALLOC_TAG);
     if (!ei) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     ei->refcount = rc;
     ei->generation = mr->ei->generation;
     ei->flags = mr->ei->flags;
     ptr = (UINT8*)&ei[1];
-    
+
     if (!(Vcb->superblock.incompat_flags & BTRFS_INCOMPAT_FLAGS_SKINNY_METADATA)) {
         EXTENT_ITEM2* ei2 = (EXTENT_ITEM2*)ptr;
-        
+
         ei2->firstitem = *(KEY*)&mr->data[1];
         ei2->level = mr->data->level;
-        
+
         ptr += sizeof(EXTENT_ITEM2);
     }
-    
+
     le = mr->refs.Flink;
     while (le != &mr->refs) {
         metadata_reloc_ref* ref = CONTAINING_RECORD(le, metadata_reloc_ref, list_entry);
-        
+
         if (ref == first_noninline)
             break;
-        
+
         *ptr = ref->type;
         ptr++;
-        
+
         if (ref->type == TYPE_TREE_BLOCK_REF) {
             TREE_BLOCK_REF* tbr = (TREE_BLOCK_REF*)ptr;
-            
+
             tbr->offset = ref->tbr.offset;
-            
+
             ptr += sizeof(TREE_BLOCK_REF);
         } else if (ref->type == TYPE_SHARED_BLOCK_REF) {
             SHARED_BLOCK_REF* sbr = (SHARED_BLOCK_REF*)ptr;
-            
+
             sbr->offset = ref->parent->new_address;
-            
+
             ptr += sizeof(SHARED_BLOCK_REF);
         }
-        
+
         le = le->Flink;
     }
-    
-    if (Vcb->superblock.incompat_flags & BTRFS_INCOMPAT_FLAGS_SKINNY_METADATA) {
-        if (!insert_tree_item(Vcb, Vcb->extent_root, mr->new_address, TYPE_METADATA_ITEM, mr->data->level, ei, inline_len, NULL, NULL, rollback)) {
-            ERR("insert_tree_item failed\n");
-            return STATUS_INTERNAL_ERROR;
-        }
-    } else {
-        if (!insert_tree_item(Vcb, Vcb->extent_root, mr->new_address, TYPE_EXTENT_ITEM, Vcb->superblock.node_size, ei, inline_len, NULL, NULL, rollback)) {
-            ERR("insert_tree_item failed\n");
-            return STATUS_INTERNAL_ERROR;
-        }
+
+    if (Vcb->superblock.incompat_flags & BTRFS_INCOMPAT_FLAGS_SKINNY_METADATA)
+        Status = insert_tree_item(Vcb, Vcb->extent_root, mr->new_address, TYPE_METADATA_ITEM, mr->data->level, ei, inline_len, NULL, NULL);
+    else
+        Status = insert_tree_item(Vcb, Vcb->extent_root, mr->new_address, TYPE_EXTENT_ITEM, Vcb->superblock.node_size, ei, inline_len, NULL, NULL);
+
+    if (!NT_SUCCESS(Status)) {
+        ERR("insert_tree_item returned %08x\n", Status);
+        ExFreePool(ei);
+        return Status;
     }
-    
+
     if (!all_inline) {
         le = &first_noninline->list_entry;
-        
+
         while (le != &mr->refs) {
             metadata_reloc_ref* ref = CONTAINING_RECORD(le, metadata_reloc_ref, list_entry);
-            
+
             if (ref->type == TYPE_TREE_BLOCK_REF) {
-                TREE_BLOCK_REF* tbr;
-                
-                tbr = ExAllocatePoolWithTag(PagedPool, sizeof(TREE_BLOCK_REF), ALLOC_TAG);
-                if (!tbr) {
-                    ERR("out of memory\n");
-                    return STATUS_INSUFFICIENT_RESOURCES;
+                Status = insert_tree_item(Vcb, Vcb->extent_root, mr->new_address, TYPE_TREE_BLOCK_REF, ref->tbr.offset, NULL, 0, NULL, NULL);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("insert_tree_item returned %08x\n", Status);
+                    return Status;
                 }
-                
-                tbr->offset = ref->tbr.offset;
-                
-                if (!insert_tree_item(Vcb, Vcb->extent_root, mr->new_address, TYPE_TREE_BLOCK_REF, tbr->offset, tbr, sizeof(TREE_BLOCK_REF), NULL, NULL, rollback)) {
-                    ERR("insert_tree_item failed\n");
-                    return STATUS_INTERNAL_ERROR;
-                }
             } else if (ref->type == TYPE_SHARED_BLOCK_REF) {
-                SHARED_BLOCK_REF* sbr;
-                
-                sbr = ExAllocatePoolWithTag(PagedPool, sizeof(SHARED_BLOCK_REF), ALLOC_TAG);
-                if (!sbr) {
-                    ERR("out of memory\n");
-                    return STATUS_INSUFFICIENT_RESOURCES;
+                Status = insert_tree_item(Vcb, Vcb->extent_root, mr->new_address, TYPE_SHARED_BLOCK_REF, ref->parent->new_address, NULL, 0, NULL, NULL);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("insert_tree_item returned %08x\n", Status);
+                    return Status;
                 }
-                
-                sbr->offset = ref->parent->new_address;
-                
-                if (!insert_tree_item(Vcb, Vcb->extent_root, mr->new_address, TYPE_SHARED_BLOCK_REF, sbr->offset, sbr, sizeof(SHARED_BLOCK_REF), NULL, NULL, rollback)) {
-                    ERR("insert_tree_item failed\n");
-                    return STATUS_INTERNAL_ERROR;
-                }
             }
-            
+
             le = le->Flink;
         }
     }
-    
+
     if (ei->flags & EXTENT_ITEM_SHARED_BACKREFS || mr->data->flags & HEADER_FLAG_SHARED_BACKREF || !(mr->data->flags & HEADER_FLAG_MIXED_BACKREF)) {
         if (mr->data->level > 0) {
             UINT16 i;
             internal_node* in = (internal_node*)&mr->data[1];
-                        
+
             for (i = 0; i < mr->data->num_items; i++) {
                 UINT64 sbrrc = find_extent_shared_tree_refcount(Vcb, in[i].address, mr->address, NULL);
 
                 if (sbrrc > 0) {
-                    NTSTATUS Status;
                     SHARED_BLOCK_REF sbr;
-                    
+
                     sbr.offset = mr->new_address;
-                    
-                    Status = increase_extent_refcount(Vcb, in[i].address, Vcb->superblock.node_size, TYPE_SHARED_BLOCK_REF, &sbr, NULL, 0,
-                                                      NULL, rollback);
+
+                    Status = increase_extent_refcount(Vcb, in[i].address, Vcb->superblock.node_size, TYPE_SHARED_BLOCK_REF, &sbr, NULL, 0, NULL);
                     if (!NT_SUCCESS(Status)) {
                         ERR("increase_extent_refcount returned %08x\n", Status);
                         return Status;
                     }
-        
+
                     sbr.offset = mr->address;
-                    
+
                     Status = decrease_extent_refcount(Vcb, in[i].address, Vcb->superblock.node_size, TYPE_SHARED_BLOCK_REF, &sbr, NULL, 0,
-                                                      sbr.offset, FALSE, NULL, rollback);
+                                                      sbr.offset, FALSE, NULL);
                     if (!NT_SUCCESS(Status)) {
                         ERR("decrease_extent_refcount returned %08x\n", Status);
                         return Status;
@@ -429,86 +475,84 @@
         } else {
             UINT16 i;
             leaf_node* ln = (leaf_node*)&mr->data[1];
-            
+
             for (i = 0; i < mr->data->num_items; i++) {
                 if (ln[i].key.obj_type == TYPE_EXTENT_DATA && ln[i].size >= sizeof(EXTENT_DATA) - 1 + sizeof(EXTENT_DATA2)) {
                     EXTENT_DATA* ed = (EXTENT_DATA*)((UINT8*)mr->data + sizeof(tree_header) + ln[i].offset);
-                    
+
                     if (ed->type == EXTENT_TYPE_REGULAR || ed->type == EXTENT_TYPE_PREALLOC) {
                         EXTENT_DATA2* ed2 = (EXTENT_DATA2*)ed->data;
-                        
+
                         if (ed2->size > 0) { // not sparse
-                            UINT64 sdrrc = find_extent_shared_data_refcount(Vcb, ed2->address, mr->address, NULL);
-                            
+                            UINT32 sdrrc = find_extent_shared_data_refcount(Vcb, ed2->address, mr->address, NULL);
+
                             if (sdrrc > 0) {
-                                NTSTATUS Status;
                                 SHARED_DATA_REF sdr;
                                 chunk* c;
-                                
+
                                 sdr.offset = mr->new_address;
                                 sdr.count = sdrrc;
-                                
-                                Status = increase_extent_refcount(Vcb, ed2->address, ed2->size, TYPE_SHARED_DATA_REF, &sdr, NULL, 0,
-                                                                  NULL, rollback);
+
+                                Status = increase_extent_refcount(Vcb, ed2->address, ed2->size, TYPE_SHARED_DATA_REF, &sdr, NULL, 0, NULL);
                                 if (!NT_SUCCESS(Status)) {
                                     ERR("increase_extent_refcount returned %08x\n", Status);
                                     return Status;
                                 }
-                                
+
                                 sdr.offset = mr->address;
-                                
+
                                 Status = decrease_extent_refcount(Vcb, ed2->address, ed2->size, TYPE_SHARED_DATA_REF, &sdr, NULL, 0,
-                                                                  sdr.offset, FALSE, NULL, rollback);
+                                                                  sdr.offset, FALSE, NULL);
                                 if (!NT_SUCCESS(Status)) {
                                     ERR("decrease_extent_refcount returned %08x\n", Status);
                                     return Status;
                                 }
-                                
+
                                 c = get_chunk_from_address(Vcb, ed2->address);
-                                
+
                                 if (c) {
                                     // check changed_extents
-                                    
+
                                     ExAcquireResourceExclusiveLite(&c->changed_extents_lock, TRUE);
-                                    
+
                                     le = c->changed_extents.Flink;
-                                    
+
                                     while (le != &c->changed_extents) {
                                         changed_extent* ce = CONTAINING_RECORD(le, changed_extent, list_entry);
-                                        
+
                                         if (ce->address == ed2->address) {
                                             LIST_ENTRY* le2;
-                                            
+
                                             le2 = ce->refs.Flink;
                                             while (le2 != &ce->refs) {
                                                 changed_extent_ref* cer = CONTAINING_RECORD(le2, changed_extent_ref, list_entry);
-                                                
+
                                                 if (cer->type == TYPE_SHARED_DATA_REF && cer->sdr.offset == mr->address) {
                                                     cer->sdr.offset = mr->new_address;
                                                     break;
                                                 }
-                                                
+
                                                 le2 = le2->Flink;
                                             }
-                                            
+
                                             le2 = ce->old_refs.Flink;
                                             while (le2 != &ce->old_refs) {
                                                 changed_extent_ref* cer = CONTAINING_RECORD(le2, changed_extent_ref, list_entry);
-                                                
+
                                                 if (cer->type == TYPE_SHARED_DATA_REF && cer->sdr.offset == mr->address) {
                                                     cer->sdr.offset = mr->new_address;
                                                     break;
                                                 }
-                                                
+
                                                 le2 = le2->Flink;
                                             }
-                                            
+
                                             break;
                                         }
-                                        
+
                                         le = le->Flink;
                                     }
-                                    
+
                                     ExReleaseResourceLite(&c->changed_extents_lock);
                                 }
                             }
